#ifndef SDL_pad_h_
#define SDL_pad_h_

#include "SDL.h"

#ifdef __cplusplus
extern "C" {
#endif

#include "SDL_padconst.h"

/** @@@
 * @@@ դƤΤϰŪʥ
 * SDL_pad ̾դΤϴĥäƺȤ礤Τ
 * ǥŪˤ϶ľ̤ˤܻؤ
 */

/** @@@
 * ޤܥγǰˤĤ
 * ܡɡ祤ƥåޥ汦SDL_QUIT ܥȸƤ
 * 桼ܥϲƤ뤫Ƥʤ 0  1 ͤ
 * 桼ܥʣΥܥ OR ˤäƼ¸
 * 桼ܥˤ ID ꤳϼưŪ˳Ƥ
 * ǥեȤ ID ñΥܥˤäƤ
 */

/** @@@
 * 
 */
extern DECLSPEC int Pad_Init();

/** @@@
 * 
 * @param flags PAD_PUMP_* ¡
 */
extern DECLSPEC void Pad_Pump(Uint32 flags);

/**
 * @return ʤ鲡Ƥ롣 1 ʤ麣󲡤줿
 *         ʤΥƤ롣 0 ʤ麣Υ줿
 */
extern DECLSPEC int Pad_GetButton(int id);

/**
 * Push  Pull Ͻִ
 */
extern DECLSPEC int Pad_GetButtonPushed(int id);
extern DECLSPEC int Pad_GetButtonPressed(int id);
extern DECLSPEC int Pad_GetButtonPulled(int id);
extern DECLSPEC int Pad_GetButtonReleased(int id);

/** @@@
 *  ID ϥ桼Ͽ뤳ȤǤ
 * äư id Ǥɬפ
 *  addid ǤɬפäƤɤȻפ
 * ĤΥ桼ܥ 8 İʾܥϿǤޤ
 * ȥ桼ܥ 80 Ĥޤ
 */
extern DECLSPEC int Pad_AddButton(int id, int addid);

extern DECLSPEC int Pad_GetAxis(int id);

extern DECLSPEC void Pad_AddAxis(int id, int upid, int rightid, int downid, int leftid);

/** @@@
 * ĤΥإ
 * Ȥ߹碌Ȥʤ
 */
extern DECLSPEC void Pad_AddAxisKeyboardArrow(int id);
extern DECLSPEC void Pad_AddAxisKeyboardRogue(int id);
extern DECLSPEC void Pad_AddAxisKeyboardWASD(int id);
extern DECLSPEC void Pad_AddAxisJoystick1(int id);
extern DECLSPEC void Pad_AddAxisJoystick2(int id);

/** @@@
 * ɤ߽Ф
 */
extern DECLSPEC int Pad_LoadDefault(const char* file);
/** @@@
 * ޥåԥ󥰤Ĥɤ߽Ф
 */
extern DECLSPEC int Pad_Load(const char* file, char** bnames, char** anames);

extern DECLSPEC int Pad_LoadRW(SDL_RWops* op, char** bnames, char** anames);

/** @@@
 * 񤭽Ф
 */
extern DECLSPEC int Pad_SaveDefault(const char* file);
/** @@@
 * ޥåԥ󥰤Ĥ񤭽Ф
 */
extern DECLSPEC int Pad_Save(const char* file, char** bnames, char** anames);

extern DECLSPEC int Pad_SaveRW(SDL_RWops* op, char** bnames, char** anames);

/** @@@
 * ʾ򤤤 PAD ץǶ̤˹Ԥߤ
 * 㤨 A ܥ Z  B ܥ X ߤʥ桼
 * ¾ΥǤ⤽֤Ȥ
 * .sdlpad ΥץåȥۡʰưǤɬפ
 *  NES ʤ󤫤ϱ A, B Ｑ¤ӤʤΤǤɡ
 * Τؤˤʤʤʡ
 */

/** @@@
 * åץ쥤
 */
extern DECLSPEC Sint16 Pad_JoystickGetAxis(SDL_Joystick* joystick, int axis, Uint32 mode);
extern DECLSPEC Uint8 Pad_JoystickGetButton(SDL_Joystick* joystick, int button);

/** @@@
 * 祤ƥå threshold ꤹ
 * @param val 
 */
extern DECLSPEC void Pad_SetJoystickThreshold(int joy, int val, int axis);
extern DECLSPEC void Pad_SetJoystickThresholdUp(int joy, int val);
extern DECLSPEC void Pad_SetJoystickThresholdRight(int joy, int val);
extern DECLSPEC void Pad_SetJoystickThresholdDown(int joy, int val);
extern DECLSPEC void Pad_SetJoystickThresholdLeft(int joy, int val);

/** @@@
 * ٥Ȥ PadKey Ф
 * Event handling ǥǰ¸äΤ
 */
extern DECLSPEC PadKey Pad_PadKeyFromEvent(SDL_Event* ev);

#define Pad_GetError SDL_GetError
#define Pad_SetError SDL_SetError

#ifdef __cplusplus
}
#endif

#endif // ! SDL_pad_h_

