#include <stdlib.h>
#include "fontlist.h"
#include <fontconfig/fontconfig.h>

struct FontList {
	FcFontSet *fs;
	int index;
};


FontList *
fontlist_open(void)
{
	FontList *fl = malloc( sizeof(*fl) );
	FcPattern *pat = FcPatternCreate();
	FcResult res;

	FcDefaultSubstitute( pat );

	fl->fs = FcFontSort( NULL, pat, FcTrue, NULL, &res );

	FcPatternDestroy( pat );

	fl->index = 0;
	return fl;
}

char *
fontlist_next_file( FontList *fl )
{
	FcChar8 *fname;
	FcResult res;

	if ( fl->index >= fl->fs->nfont ) 
		return NULL;

	res = FcPatternGetString( fl->fs->fonts[fl->index], FC_FILE, 0, &fname );
	fl->index++;
	return (char*)fname;
}

void
fontlist_close( FontList *fl )
{
	FcFontSetDestroy( fl->fs );
	free( fl );
}
